#pragma once
#include "States/States.h"

class Application : public IStateManager {
public:
    static Application& Instance() {
        static Application instance;
        return instance;
    }
    Application(const IStateManager&) = delete;
    Application& operator=(const Application&) = delete;
    int run();
private:
    Application() = default;
    ~Application() override = default;
    void set_next_state(std::unique_ptr<IState> state) override { m_ptr_state_next = std::move(state); };
    void apply_deffer_state_change();
    std::unique_ptr<IState> m_ptr_state_current = std::make_unique<SelectState>(*this, sf::VideoMode{100, 50}, sf::String{"Select state"});
    std::unique_ptr<IState> m_ptr_state_next;
};