#pragma once
#include <iostream>
#include "IState.h"
#include "../IWindowKeeper.h"

struct ExitState : IState {
    explicit ExitState(IStateManager& state_manager) : IState(state_manager) {}
    bool do_step() override {
        std::cout << "Exiting..." << std::endl;
        return false;
    }
};

struct SelectState : IState, IWindowKeeper {
    explicit SelectState(IStateManager& state_manager, const sf::VideoMode& video_mode, const sf::String& window_title) : IState(state_manager), IWindowKeeper(video_mode, window_title) {}
    bool do_step() override;
    void event_handling() override {};
    void update() override {};
    void render() override {};
};

struct GameState : IState, IWindowKeeper {
    explicit GameState(IStateManager& state_manager, const sf::VideoMode& video_mode, const sf::String& window_title) : IState(state_manager), IWindowKeeper(video_mode, window_title) {}
    bool do_step() override;
    void event_handling() override {};
    void update() override {};
    void render() override {};
};